"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
Parameters for pagination.

Copyright 2023 Frequenz Energy-as-a-Service GmbH

Licensed under the MIT License (the "License");
you may not use this file except in compliance with the License.
"""
import builtins
import google.protobuf.descriptor
import google.protobuf.message
import sys

if sys.version_info >= (3, 8):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing_extensions.final
class PaginationInfo(google.protobuf.message.Message):
    """A message providing metadata about paginated list results.
    The PaginationInfo message delivers metadata concerning the paginated list
    results and should be appended to the response message of a list request. The
    total_items field must be set to the total count of items that adhere to the
    filter criteria defined in the request. The next_page_token field should be
    populated with the token to be used in the subsequent request to fetch the
    next page of results. If there are no additional results, the next_page_token
    field should be omitted.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TOTAL_ITEMS_FIELD_NUMBER: builtins.int
    NEXT_PAGE_TOKEN_FIELD_NUMBER: builtins.int
    total_items: builtins.int
    """The total number of items that match the filter criteria defined in the
    request.
    """
    next_page_token: builtins.str
    """Token for retrieving the next set of results."""
    def __init__(
        self,
        *,
        total_items: builtins.int = ...,
        next_page_token: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["_next_page_token", b"_next_page_token", "next_page_token", b"next_page_token"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["_next_page_token", b"_next_page_token", "next_page_token", b"next_page_token", "total_items", b"total_items"]) -> None: ...
    def WhichOneof(self, oneof_group: typing_extensions.Literal["_next_page_token", b"_next_page_token"]) -> typing_extensions.Literal["next_page_token"] | None: ...

global___PaginationInfo = PaginationInfo
